local FOLIAGE_COLOR = SKINCOLOR_AQUA

// anything that is not referenced by a mapthing needs to be retrieved from the thinker list
local objectTypeList = {
	MT_ANIMALGAETOP,
	MT_ANIMALGAESEG
}

// anything with MF_NOTHINK needs to be retrieved from the mapthing list
local mapThingObjectTypeList = {
	MT_BIG_PALMTREE_TOP,
	MT_PALMTREE_TOP
}

local function RecolorObject(mo, list)
	for _, type in ipairs(list)
		if mo.type == type
			mo.color = FOLIAGE_COLOR
			break
		end
	end
end

addHook("MapLoad", function(map)
	if map ~= (OLDC and OLDC.hub)
		return
	end
	
	for mt in mapthings.iterate
		local mo = mt.mobj
		
		if not (mo and mo.valid)
			continue
		end
		
		RecolorObject(mo, mapThingObjectTypeList)
	end
	
	for mo in mobjs.iterate()
		RecolorObject(mo, objectTypeList)
	end
end)