/*
Acidic Alpines Zone Flowers
	by Lach

v1
*/

// (the cloud sprites are included because I don't want to rename the frames LOL)

// To prevent duplicate freeslots
local function CheckSlot(item) // this function deliberately errors when a freeslot does not exist
	if _G[item] == nil // this will error by itself for states and objects
		error() // this forces an error for sprites, which do actually return nil for some reason
	end
end

local function SafeFreeslot(...)
	local item = ...
	if item == nil
		return
	end
	
	if pcall(CheckSlot, item)
		print("\131NOTICE:\128 " .. item .. " was not allocated, as it already exists.")
	else
		freeslot(item)
	end
	
	SafeFreeslot(select(2, ...))
end

SafeFreeslot("SPR_ALPF", "S_AALPFLOWER1", "S_AALPFLOWER2", "S_AALPFLOWER3", "S_AALPFLOWER4", "S_AALPFLOWER5", "S_AALPROSE",
	"MT_AALPFLOWER", "MT_AALPROSE")

// Flower

states[S_AALPFLOWER1] = {
	sprite = SPR_ALPF,
	frame = 12|FF_ANIMATE,
	var1 = 39,
	var2 = 3,
	tics = 9,
	nextstate = S_AALPFLOWER2
}

states[S_AALPFLOWER2] = {
	sprite = SPR_ALPF,
	frame = 15|FF_ANIMATE,
	var1 = 39,
	var2 = 2,
	tics = 10,
	nextstate = S_AALPFLOWER3
}

states[S_AALPFLOWER3] = {
	sprite = SPR_ALPF,
	frame = 20|FF_ANIMATE,
	var1 = 39,
	var2 = 1,
	tics = 23,
	nextstate = S_AALPFLOWER4
}

states[S_AALPFLOWER4] = {
	sprite = SPR_ALPF,
	frame = 43|FF_ANIMATE,
	var1 = 39,
	var2 = 2,
	tics = 10,
	nextstate = S_AALPFLOWER5
}

states[S_AALPFLOWER5] = {
	sprite = SPR_ALPF,
	frame = 48|FF_ANIMATE,
	var1 = 39,
	var2 = 3,
	tics = 12,
	nextstate = S_AALPFLOWER1
}

mobjinfo[MT_AALPFLOWER] = {
	--$Name Acidic Alpines Flower
	--$Sprite ALPFM0
	--$Category Acidic Alpines
	--$Flags8Text Cave variant
	doomednum = 2780,
	spawnhealth = 1000,
	height = 48*FRACUNIT,
	radius = 16*FRACUNIT,
	flags = MF_SCENERY,
	spawnstate = S_AALPFLOWER1
}

// Rose

states[S_AALPROSE] = {
	sprite = SPR_ALPF,
	frame = E|FF_ANIMATE,
	var1 = 7,
	var2 = 3
}

mobjinfo[MT_AALPROSE] = {
	--$Name Acidic Alpines Rose
	--$Sprite ALPFE0
	--$Category Acidic Alpines
	--$Flags8Text Cave variant
	doomednum = 2781,
	spawnhealth = 1000,
	height = 16*FRACUNIT,
	radius = 8*FRACUNIT,
	flags = MF_SCENERY,
	spawnstate = S_AALPROSE
}

